#ifndef EQUIS_ARRAY_HPP
#define EQUIS_ARRAY_HPP

EQUIS_ENTER_NS1(equis);

template < typename T >
class array {
	EQUIS_NO_COPY(array);
public:
    typedef array<T> this_type;
    typedef T value_type;
    typedef value_type* pointer;
    typedef value_type& reference;
    typedef const value_type& const_reference;
    typedef value_type* iterator;
    typedef const value_type* const_iterator;

    array();
    array(T* ptr, long size, bool free_ptr = false);
    ~array();

    void clear(const T& value = T());
	bool resize(long size, const T& value = T());
    
    long size() const;

    bool valid(long index) const;

    T& operator [] (long index);
    const T& operator [] (long index) const;

    iterator begin();
    iterator end();
    const_iterator begin() const;
    const_iterator end() const;
    
private:
    T* m_ptr;
    long m_size;
    bool m_free_ptr;
};

EQUIS_LEAVE_NS1(equis);

#define IN_EQUIS_ARRAY_HPP
#include "array.inl"
#undef IN_EQUIS_ARRAY_HPP

#endif /* EQUIS_ARRAY_HPP */
