#ifndef EQUIS_CASTS_HPP
#define EQUIS_CASTS_HPP

EQUIS_ENTER_NS1(equis);

/// Safely converts between compatible types.
template < typename T, typename TFrom > inline T
implicit_cast(const TFrom &value);

/// Converts a pointer to one of its subclasses.
template < typename T, typename TFrom > inline T
narrow_cast(TFrom value);

/// Converts a pointer to a pointer to an equal-sized type.
template < typename T, typename TFrom > inline T
pointer_cast(TFrom value);

/// Converts a pointer-to-pointer to a pointer-to-void-pointer.
template < typename TFrom > inline void**
void_cast(TFrom** ptr);

/// Reinterprets the content of a value as an equal-sized type.
template < typename T, typename TFrom > inline T
raw_cast(const TFrom &value);

EQUIS_LEAVE_NS1(equis);

#define IN_EQUIS_CASTS_HPP
#include "casts.inl"
#undef IN_EQUIS_CASTS_HPP

#endif /* EQUIS_CASTS_HPP */
