#ifndef IN_EQUIS_CASTS_HPP
#error This file must be included via casts.hpp
#endif

EQUIS_ENTER_NS1(equis);

template < typename T, typename TFrom > inline
T
implicit_cast(const TFrom &value) {
    T result = value;
    return result;
}

template < typename T, typename TFrom > inline
T
narrow_cast(TFrom value) {
    return reinterpret_cast<T>(value);
}

template < typename T, typename TFrom > inline
T
pointer_cast(TFrom value) {
    EQUIS_STATIC_ASSERT(sizeof(T) == sizeof(TFrom));
    return reinterpret_cast<T>(value);
}

template < typename TFrom > inline
void**
void_cast(TFrom** ptr) {
    return pointer_cast<void**>(ptr);
}

template < typename T, typename TFrom > inline
T
raw_cast(const TFrom &value) {
    EQUIS_STATIC_ASSERT(sizeof(T) == sizeof(TFrom));
    return *reinterpret_cast<T*>(&value);
}

EQUIS_LEAVE_NS1(equis);
