#ifndef IN_EQUIS_IMAGE_IMAGE_HPP
#error This file must be included via image.hpp
#endif /* IN_EQUIS_IMAGE_IMAGE_HPP */

EQUIS_ENTER_NS2(equis,image);

template < typename DstTraits, typename SrcTraits > inline
void convertImage(
	void* dst, const void* src,
	long rows, long cols, bool vflip)
{
	DstTraits::Image dst_image(dst, rows, cols);
	SrcTraits::ConstImage src_image(src, rows, cols);

	for (long row = 0; row < rows; ++row) {
		long dst_row = vflip ? rows - 1 - row : row;

		for (long col = 0; col < cols; ++col) {
			convertPixel(dst_image(dst_row, col), src_image(row, col));
		}
	}
}

EQUIS_LEAVE_NS2(equis,image);
