#ifndef IN_EQUIS_TYPES_HPP
#error This file must be included via "types.hpp"
#endif

EQUIS_ENTER_NS1(equis);

template <> struct numeric_traits<int8> {
    typedef void assert_integer;
    typedef void assert_signed;
    typedef int16 promoted_type;
};

template <> struct numeric_traits<uint8> {
    typedef void assert_integer;
    typedef void assert_unsigned;
    typedef uint16 promoted_type;
};

template <> struct numeric_traits<int16> {
    typedef void assert_integer;
    typedef void assert_signed;
    typedef int32 promoted_type;
};

template <> struct numeric_traits<uint16> {
    typedef void assert_integer;
    typedef void assert_unsigned;
    typedef uint32 promoted_type;
};

template <> struct numeric_traits<int32> {
    typedef void assert_integer;
    typedef void assert_signed;
    typedef int64 promoted_type;
};

template <> struct numeric_traits<uint32> {
    typedef void assert_integer;
    typedef void assert_unsigned;
    typedef uint64 promoted_type;
};

template <> struct numeric_traits<flt32> {
    typedef void assert_signed;
    typedef flt32 promoted_type;
};

template <> struct numeric_traits<flt64> {
    typedef void assert_signed;
    typedef flt64 promoted_type;
};

EQUIS_LEAVE_NS1(equis);
