#ifndef EQUIS_WIN32_BASEUNKNOWN_HPP
#define EQUIS_WIN32_BASEUNKNOWN_HPP

#define BASEUNKNOWN_DECLARE(Base) \
public: \
STDMETHOD(QueryInterface)(REFIID iid, void** result); \
STDMETHOD_(ULONG, AddRef)() { \
    return Base::AddRef(); \
} \
STDMETHOD_(ULONG, Release)() { \
    return Base::Release(); \
}
// END BASEUNKNOWN_DECLARE

EQUIS_ENTER_NS1(equis);

/// A base class for COM objects.
///
/// Deriving classes should use the BASEUNKNOWN_DECLARE to delegate IUnknown
/// methods to BaseUnknown, and must implement InnerQueryInterface.
class BaseUnknown : public IUnknown
{
public:
    // IUnknown
    STDMETHOD(QueryInterface)(REFIID iid, void** result);
    STDMETHOD_(ULONG, AddRef)(VOID);
    STDMETHOD_(ULONG, Release)(VOID);

protected:
    BaseUnknown();
    virtual ~BaseUnknown();

private:
    volatile LONG m_referenceCount;
};

EQUIS_LEAVE_NS1(equis);

#define IN_EQUIS_WIN32_BASEUNKNOWN_HPP
#include "BaseUnknown.inl"
#undef IN_EQUIS_WIN32_BASEUNKNOWN_HPP

#endif /* EQUIS_WIN32_BASEUNKNOWN_HPP */
