#ifndef IN_EQUIS_WIN32_MUTEX_HPP
#error This file must be included via Mutex.hpp
#endif

EQUIS_ENTER_NS1(equis);

inline
MutexLock::MutexLock(Mutex *parent)
  : m_parent(parent), m_entered(false)
{
}

inline
MutexLock::~MutexLock() {
    HRESULT res = S_OK;

    if (m_parent != NULL && m_entered) {
        res = m_parent->Leave();
    }

    EQUIS_DEBUG_ASSERT(res == S_OK);
}

inline HRESULT
MutexLock::Enter(DWORD timeoutMs) {
    HRESULT res = S_OK;

    if (m_parent == NULL) {
        res = E_POINTER;
    }
    else {
        res = m_parent->Enter(timeoutMs);

        if (SUCCEEDED(res)) {
            m_entered = true;
        }
    }

    EQUIS_DEBUG_ASSERT(res == S_OK);
    return res;
}

inline void
MutexLock::SetEntered() {
	m_entered = true;
}

EQUIS_LEAVE_NS1(equis);
