#ifndef EQUIS_IMAGE_FILTER_HPP
#define EQUIS_IMAGE_FILTER_HPP

EQUIS_USING_NS1(equis);

struct pixel_rgb32 {
	uint8 r, g, b, a;
};

void
combine(const array2<uint8> &rsrc,
		const array2<uint8> &gsrc,
		const array2<uint8> &bsrc,
		array2<pixel_rgb32> &dst);

void
combine(const array2<uint16> &rsrc,
		const array2<uint16> &gsrc,
		const array2<uint16> &bsrc,
		array2<pixel_rgb32> &dst);

void
band_low(const array2<uint16>& src, array2<uint16>& tmp, array2<uint16>& dst, int outer);

void
band_mid(const array2<uint16>& src, array2<uint16>& tmp, array2<uint16>& dst, int outer, int inner);

#endif /* EQUIS_IMAGE_FILTER_H */
