#include "common.hpp"
#include "filter.hpp"

#if 0
void
combine(const array2<uint8> &rsrc,
		const array2<uint8> &gsrc,
		const array2<uint8> &bsrc,
		array2<pixel_rgb24> &dst)
{
	size_t rows = rsrc.rows();
	size_t cols = rsrc.cols();

	// Check that all input sizes are identical.
	_ASSERT(rsrc.rows() == rows);
	_ASSERT(rsrc.cols() == cols);
	_ASSERT(gsrc.rows() == rows);
	_ASSERT(gsrc.cols() == cols);
	_ASSERT(bsrc.rows() == rows);
	_ASSERT(bsrc.cols() == cols);

	dst.resize(rows, cols);
	array2<uint8>::const_iterator
		rit = rsrc.begin(), rend = rsrc.end(),
		git = gsrc.begin(),
		bit = bsrc.begin();
	array2<pixel_rgb24>::iterator dit = dst.begin();
	
	for (; rit != rend; ++rit, ++git, ++bit, ++dit) {
		dit->r = *rit;
		dit->g = *git;
		dit->b = *bit;
	}
}
#endif

void
combine(const array2<uint8> &rsrc,
		const array2<uint8> &gsrc,
		const array2<uint8> &bsrc,
		array2<pixel_rgb32> &dst)
{
	size_t rows = rsrc.rows();
	size_t cols = rsrc.cols();

	// Check that all input sizes are identical.
	_ASSERT(rsrc.rows() == rows);
	_ASSERT(rsrc.cols() == cols);
	_ASSERT(gsrc.rows() == rows);
	_ASSERT(gsrc.cols() == cols);
	_ASSERT(bsrc.rows() == rows);
	_ASSERT(bsrc.cols() == cols);

	dst.resize(rows, cols);
	array2<uint8>::const_iterator
		rit = rsrc.begin(), rend = rsrc.end(),
		git = gsrc.begin(),
		bit = bsrc.begin();
	array2<pixel_rgb32>::iterator dit = dst.begin();
	
	for (; rit != rend; ++rit, ++git, ++bit, ++dit) {
		dit->r = *rit;
		dit->g = *git;
		dit->b = *bit;
		dit->a = 0xFF;
	}
}

#if 0

void equis::image::
combine(const array2<uint16> &rsrc,
		const array2<uint16> &gsrc,
		const array2<uint16> &bsrc,
		array2<pixel_rgb24> &dst)
{
	size_t rows = rsrc.rows();
	size_t cols = rsrc.cols();

	// Check that all input sizes are identical.
	_ASSERT(rsrc.rows() == rows);
	_ASSERT(rsrc.cols() == cols);
	_ASSERT(gsrc.rows() == rows);
	_ASSERT(gsrc.cols() == cols);
	_ASSERT(bsrc.rows() == rows);
	_ASSERT(bsrc.cols() == cols);

	dst.resize(rows, cols);
	array2<uint16>::const_iterator
		rit = rsrc.begin(), rend = rsrc.end(),
		git = gsrc.begin(),
		bit = bsrc.begin();
	array2<pixel_rgb24>::iterator dit = dst.begin();
	
	for (; rit != rend; ++rit, ++git, ++bit, ++dit) {
		dit->r = *rit >> 8;
		dit->g = *git >> 8;
		dit->b = *bit >> 8;
	}
}
#endif

void
combine(const array2<uint16> &rsrc,
		const array2<uint16> &gsrc,
		const array2<uint16> &bsrc,
		array2<pixel_rgb32> &dst)
{
	size_t rows = rsrc.rows();
	size_t cols = rsrc.cols();

	// Check that all input sizes are identical.
	_ASSERT(rsrc.rows() == rows);
	_ASSERT(rsrc.cols() == cols);
	_ASSERT(gsrc.rows() == rows);
	_ASSERT(gsrc.cols() == cols);
	_ASSERT(bsrc.rows() == rows);
	_ASSERT(bsrc.cols() == cols);

	dst.resize(rows, cols);
	array2<uint16>::const_iterator
		rit = rsrc.begin(), rend = rsrc.end(),
		git = gsrc.begin(),
		bit = bsrc.begin();
	array2<pixel_rgb32>::iterator dit = dst.begin();
	
	for (; rit != rend; ++rit, ++git, ++bit, ++dit) {
		dit->r = *rit >> 8;
		dit->g = *git >> 8;
		dit->b = *bit >> 8;
		dit->a = 0xFF;
	}
}
