#ifndef EQUIS_VIDEO_DSHOW_DSINPUT_HPP
#define EQUIS_VIDEO_DSHOW_DSINPUT_HPP

#include "video/input_spi.h"
#include "Utility/MediaType.hpp"

class DSInputSink;

HRESULT MediaTypeToFormat(EVFormat* dst, const AM_MEDIA_TYPE* src);

class DSInput : public EVInput {
public:
	DSInput(const EVInputSpi* spi, IBaseFilter* source, HRESULT& res);
	DSInput(const EVInputSpi* spi, const char* path, HRESULT& res);
	~DSInput();

	int Close();
	long GetFormats(long start, EVFormat* formats, int formats_cap);
	int SetFormat(EVFormat* format);
	int GetFormat(EVFormat* format);
	EVInputFrame* Poll();
	EVInputFrame* Next();
	int Callback(EVICallbackProc callback, void* user);
	int Done(EVInputFrame* frame);

	int Geti(int name, int* value);
	int Getf(int name, float* value);
	int Seti(int name, int value);
	int Setf(int name, float value);
	int GetCapsf(int name, float* min, float* max, float* step, float* def);
	int GetStopsf(int name, float* stops, int stops_cap);

private:
	equis::Mutex m_lock;

	ComPtr<IGraphBuilder> m_graph;
	ComPtr<IMediaControl> m_control;
	ComPtr<IBaseFilter> m_source;
	ComPtr<IPin> m_source_pin;
	ComPtr<DSInputSink> m_sink;
	ComPtr<IPin> m_sink_pin;

	equis::MediaTypePtr m_source_type;
	EVFormat m_actual_format;

	bool m_running;

	HRESULT InternalStart();
};

#endif /* EQUIS_VIDEO_DSHOW_DSINPUT_HPP */