#pragma once

#include "video/format.h"

extern "C" const GUID WMMEDIASUBTYPE_Y800;
extern "C" const GUID WMMEDIASUBTYPE_Y160;

HRESULT WINAPI CopyMediaType(AM_MEDIA_TYPE* dst, const AM_MEDIA_TYPE* src);
HRESULT WINAPI CloneMediaType(AM_MEDIA_TYPE** dst, const AM_MEDIA_TYPE* src);

void InitMediaType(AM_MEDIA_TYPE* mt);
void ClearMediaType(AM_MEDIA_TYPE* mt);
void DeleteMediaType(AM_MEDIA_TYPE* mt);

bool MatchesMediaType(const AM_MEDIA_TYPE* filter, const AM_MEDIA_TYPE* candidate);

// Note that this class must be kept pointer-compatible with AM_MEDIA_TYPE.
// This means no additional fields, and no virtual methods.
class MediaType
{
public:
    MediaType();
    MediaType(const MediaType& source);
    MediaType(const AM_MEDIA_TYPE* source);
    ~MediaType();

    MediaType& operator = (const MediaType& source);
    MediaType& operator = (const AM_MEDIA_TYPE* source);

    AM_MEDIA_TYPE* operator -> ();
    const AM_MEDIA_TYPE* operator -> () const;

    AM_MEDIA_TYPE* ptr();
    const AM_MEDIA_TYPE* ptr() const;

    void clear();

private:
    AM_MEDIA_TYPE m_value;
};

#define IN_DSHOW_MEDIATYPE_HPP
#include "MediaType.inl"
#undef IN_DSHOW_MEDIATYPE_HPP
