#include "common.hpp"
#include "input_spi.h"

// eviEnum, eviOpen, and eviOpenFile are implemented in VideoInputSpi.cpp

int eviClose(EVInput* handle) {
	if (!handle || !handle->spi->Close) return -1;
	return handle->spi->Close(handle);
}

int eviGetFormats(EVInput* handle, int start, EVFormat* formats, int formats_cap) {
	if (!handle || !handle->spi->GetFormats) return -1;
	return handle->spi->GetFormats(handle, start, formats, formats_cap);
}

int eviSetFormat(EVInput* handle, EVFormat* format) {
	if (!handle || !handle->spi->SetFormat) return -1;
	return handle->spi->SetFormat(handle, format);
}

int eviGetFormat(EVInput* handle, EVFormat* format) {
	if (format) *format = EVFormat();
	if (!handle || !handle->spi->GetFormat) return -1;
	return handle->spi->GetFormat(handle, format);
}

EVInputFrame* eviPoll(EVInput* handle) {
	if (!handle || !handle->spi->Poll) return NULL;
	return handle->spi->Poll(handle);
}

EVInputFrame* eviNext(EVInput* handle) {
	if (!handle || !handle->spi->Next) return NULL;
	return handle->spi->Next(handle);
}

int eviCallback(EVInput* handle, EVICallbackProc callback, void* user) {
	if (!handle || !handle->spi->Callback) return -1;
	return handle->spi->Callback(handle, callback, user);
}

const EVFormat* evifFormat(EVInputFrame* frame) {
	if (!frame || !frame->origin->spi->FrameFormat) return NULL;
	return frame->origin->spi->FrameFormat(frame);
}

long evifSize(EVInputFrame* frame) {
	if (!frame || !frame->origin->spi->FrameSize) return -1;
	return frame->origin->spi->FrameSize(frame);
}

void* evifPointer(EVInputFrame* frame) {
	if (!frame || !frame->origin->spi->FramePointer) return NULL;
	return frame->origin->spi->FramePointer(frame);
}

int evifDone(EVInputFrame* frame) {
	if (!frame || !frame->origin->spi->FrameDone) return -1;
	return frame->origin->spi->FrameDone(frame);
}

int eviGeti(EVInput* handle, int name, int* value) {
	if (value) *value = 0;
	if (!handle || !handle->spi->Geti) return -1;
	return handle->spi->Geti(handle, name, value);
}

int eviGetf(EVInput* handle, int name, float* value) {
	if (value) *value = 0;
	if (!handle || !handle->spi->Getf) return -1;
	return handle->spi->Getf(handle, name, value);
}

int eviSeti(EVInput* handle, int name, int value) {
	if (!handle || !handle->spi->Seti) return -1;
	return handle->spi->Seti(handle, name, value);
}

int eviSetf(EVInput* handle, int name, float value) {
	if (!handle || !handle->spi->Setf) return -1;
	return handle->spi->Setf(handle, name, value);
}

int eviGetCapsf(EVInput* handle, int name, float* min, float* max, float* step, float* def) {
	if (min) *min = 0;
	if (max) *max = 0;
	if (step) *step = 0;
	if (def) *def = 0;
	if (!handle || !handle->spi->GetCapsf) return -1;
	return handle->spi->GetCapsf(handle, name, min, max, step, def);
}

int eviGetStopsf(EVInput* handle, int name, float* stops, int stops_cap) {
	if (!handle || !handle->spi->GetStopsf) return -1;
	return handle->spi->GetStopsf(handle, name, stops, stops_cap);
}
