#include "common.hpp"
#include "input_spi.h"

static EVInputSpi* s_spis_head;

void eviRegisterSpi(EVInputSpi* spi) {
	if (!spi) return;

	spi->next = s_spis_head;
	s_spis_head = spi;
}

#include "dshow/DSInputSpi.hpp"

static void ensure_spis_registered() {
	if (!s_spis_head) {
		evi_dshow_register_spi();
	}
}

int eviEnum(int start, char* uris, int uris_cap) {
	ensure_spis_registered();

	// TODO: Concatenate the results from multiple SPIs
	for (EVInputSpi* spi = s_spis_head; spi; spi = spi->next) {
		return spi->Enum(spi, start, uris, uris_cap);
	}
	return -1;
}

EVInput* eviOpen(const char* uri) {
	ensure_spis_registered();

	for (EVInputSpi* spi = s_spis_head; spi; spi = spi->next) {
		EVInput* result = spi->Open(spi, uri);
		if (result) return result;
	}
	return NULL;
}

EVInput* eviOpenFile(const char* path) {
	ensure_spis_registered();

	return NULL;
}
