#include "common.hpp"
#include "xna-common.hpp"
#include "Input_VideoDeviceDialog.hpp"

#if 0
using namespace Equis::Xna::Input;
using namespace System::Windows::Forms;

VideoDeviceDialog::VideoDeviceDialog()
{
	this->Text = "Select a video capture device...";
	this->CenterToScreen();

	m_treeView = gcnew TreeView();
	Controls->Add(m_treeView);
	m_treeView->Dock = DockStyle::Fill;
	m_treeView->TabIndex = 0;
	m_treeView->HideSelection = false;
	m_treeView->AfterSelect += gcnew TreeViewEventHandler(this, &VideoDeviceDialog::OnAfterSelect);

	for each (VideoDevice ^device in VideoDevice::GetAll())
	{
		TreeNode ^deviceNode = gcnew TreeNode();
		m_treeView->Nodes->Add(deviceNode);

		deviceNode->Text = device->Name;
		deviceNode->Tag = device;

#if 0
		array<VideoFormat ^> ^formats = device->GetFormats(
			VideoFormatPreference::ManyColors,
			VideoFormatPreference::HighFrameRate,
			VideoFormatPreference::HighResolution);
		if (formats->Length > 0)
		{
			for each (VideoFormat ^format in formats)
			{
				TreeNode ^formatNode = gcnew TreeNode();
				deviceNode->Nodes->Add(formatNode);
	
				formatNode->Text = format->ToString();
				formatNode->Tag = format;
			}
		}
		else
		{
			TreeNode ^formatNode = gcnew TreeNode();
			deviceNode->Nodes->Add(formatNode);

			formatNode->Text = "No compatible formats.";
		}
#endif
	}

        {
		TreeNode ^deviceNode = gcnew TreeNode();
		m_treeView->Nodes->Add(deviceNode);

		deviceNode->Text = "Use no video input";
		deviceNode->Tag = nullptr;
        }

	FlowLayoutPanel ^buttons = gcnew FlowLayoutPanel();
	Controls->Add(buttons);
	buttons->Dock = DockStyle::Bottom;
	buttons->FlowDirection = FlowDirection::RightToLeft;

	Button ^cancelButton = gcnew Button();
	buttons->Controls->Add(cancelButton);	
	cancelButton->Text = "Cancel";
	cancelButton->TabIndex = 2;
	cancelButton->DialogResult = System::Windows::Forms::DialogResult::Cancel;

	Button ^okButton = gcnew Button();
	buttons->Controls->Add(okButton);	
	okButton->Text = "Ok";
	okButton->Enabled = false;
	okButton->TabIndex = 1;
	okButton->DialogResult = System::Windows::Forms::DialogResult::OK;

	buttons->Size = buttons->GetPreferredSize(buttons->Size);

	this->AcceptButton = okButton;
	this->CancelButton = cancelButton;

	m_okButton = okButton;
}

VideoDevice ^VideoDeviceDialog::Device::get()
{
	return m_device;
}

void VideoDeviceDialog::Device::set(VideoDevice ^device)
{
	m_device = device;
}

VideoFormat ^VideoDeviceDialog::Format::get()
{
	return m_format;
}

void VideoDeviceDialog::Format::set(VideoFormat ^format)
{
	m_format = format;
}

void VideoDeviceDialog::OnAfterSelect(Object ^source, TreeViewEventArgs ^args)
{
	Object ^tag = args->Node->Tag;
	if (tag == nullptr)
	{
		// Selected a "No compatible formats" node or the "Use no video input".
                TreeNode ^parent = args->Node->Parent;
                if (parent == nullptr) {
                    m_device = nullptr;
		    m_format = nullptr;
                    m_okButton->Enabled = true;
                }
                else {
                    m_device = (VideoDevice ^) parent->Tag;
		    m_format = nullptr;
                    m_okButton->Enabled = false;
                }
	}
	else if (VideoDevice::typeid->IsInstanceOfType(tag))
	{
		// Selected a video device.
		m_device = (VideoDevice ^) tag;
		m_format = nullptr;
        	m_okButton->Enabled = false;
	}
	else if (VideoFormat::typeid->IsInstanceOfType(tag))
	{
		// Selected a video format.
		m_device = (VideoDevice ^) args->Node->Parent->Tag;
		m_format = (VideoFormat ^) tag;
        	m_okButton->Enabled = true;
	}
	else
	{
		_ASSERT(FALSE);
        	m_okButton->Enabled = false;
	}
}
#endif